/* Copyright Statement:
 *
 * This software/firmware and related documentation ("AutoChips Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to AutoChips Inc. and/or its licensors. Without
 * the prior written permission of AutoChips inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of AutoChips Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * AutoChips Inc. (C) 2022. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("AUTOCHIPS SOFTWARE")
 * RECEIVED FROM AUTOCHIPS AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. AUTOCHIPS EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES AUTOCHIPS PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE AUTOCHIPS SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN AUTOCHIPS
 * SOFTWARE. AUTOCHIPS SHALL ALSO NOT BE RESPONSIBLE FOR ANY AUTOCHIPS SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND AUTOCHIPS'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE AUTOCHIPS SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT AUTOCHIPS'S OPTION, TO REVISE OR REPLACE THE
 * AUTOCHIPS SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO AUTOCHIPS FOR SUCH AUTOCHIPS SOFTWARE AT ISSUE.
 */
/******************************************************************************
 * @version: V2.0.1  AC7840x  Demo
 ******************************************************************************/

#include "crc.h"
#include "string.h"

uint32_t tmpResult = 0;                    /* CRC */
uint32_t tmpCRCType = CRC_PROTOCOL_32BIT;  /* CRC ֧16λ32λȶʽ */

void CRC_InitTest(void)
{
    crc_user_config_t CRCConfig;              /* CRCýṹ */
    memset(&CRCConfig, 0, sizeof(CRCConfig));

    CRCConfig.crcProtocolType = (crc_protocol_type_t)tmpCRCType;

    if (tmpCRCType == CRC_PROTOCOL_32BIT)
    {
        CRCConfig.finalXOR = 1;                /* Զݲ */
        CRCConfig.poly = 0x4C11DB7;            /* CRC-32 Poly: 0x4C11DB7 */
        CRCConfig.readTransposeType = CRC_TRANSPOSE_NONE;  /* ת */
        CRCConfig.seed = 0xFFFFFFFF;           /* 32λΪ: 0xFFFFFFFF*/
        CRCConfig.writeBytesNumOnce = CRC_WRITE_1_BYTE_ONCE;  /* CRCһдһֽ */
        CRCConfig.writeTransposeType = CRC_TRANSPOSE_BITS_BYTES; /* дֽת */
    }
    else                                        /* CRC16  */
    {
        CRCConfig.finalXOR = 0;                  /* Զݲ */
        CRCConfig.poly = 0x1021;
        CRCConfig.readTransposeType = CRC_TRANSPOSE_NONE;  /* ת */
        CRCConfig.seed = 0xFFFF;                      /* 16λΪ: 0xFFFF*/
        CRCConfig.writeBytesNumOnce = CRC_WRITE_1_BYTE_ONCE;
        CRCConfig.writeTransposeType = CRC_TRANSPOSE_NONE;
    }

    CRC_DRV_Init(0, &CRCConfig);    /* ʼCRC */

    if (CRCConfig.crcProtocolType == CRC_PROTOCOL_32BIT)
    {
        tmpResult = CRC_DRV_GetCrc32(0, 0x12345678, 0, CRCConfig.seed); /* 32λݡ0x12345678ӵǰCRC㲢ý */
        printf("CRC-32, Poly:0x%X\r\n", CRCConfig.poly);
    }
    else
    {
        tmpResult = CRC_DRV_GetCrc16(0, 0x1234, 0, CRCConfig.seed); /* 16λݡ0x1234ӵǰCRC㲢ý */
        printf("CRC-16, Poly:0x%X\r\n", CRCConfig.poly);
    }
    printf("CRC result is: 0x%X\r\n", tmpResult);
}

